Game.registerMod("Auto click Mod", {
    init: function () {

        setInterval(function () {
            for (var h in Game.shimmers) {
                Game.shimmers[h].pop();
            }
        }, 1000);


        // --- Controller
        function Controller() {
            this.notify = new Audio("https://gist.github.com/pernatiy/38bc231506b06fd85473/raw/beep-30.mp3"); //source: http://www.soundjay.com/button/beep-30b.mp3
            this.protect = true;
            this.total = -1;

            this.actions = {
                timeouts: {},
                status: { delay: 0, func: this.status.bind(this) },
                main: { delay: 50, func: function() {Game.ClickCookie(0); } },
                frenzy: { delay: 50, func: function () { if (Game.clickFrenzy > 0) Game.ClickCookie(0); } },
                season: { delay: 1000, func: function () { if (Game.seasonPopup && Game.seasonPopup.life > 0) Game.seasonPopup.click(); } },
                gold: {
                    delay: 1000,
                    func: function () {
                        if (Game.shimmers) {
                            var sha = Object.keys(Game.shimmers);

                            for (var i = 0; i < sha.length; i++) {
                                sha[i].l.click();
                            }
                        }
                    }
                },
                gnotify: { delay: 1000, func: function () { if (Game.goldenCookie && Game.goldenCookie.life > 0 && Game.goldenCookie.wrath == 0) this.play(); }.bind(this.notify) },
            };

            this.toggle_action('guard');
        }

        Controller.prototype = {
            say: function (msg, news) {
                console.log(msg);
                if (news) {
                    Game.Ticker = msg;
                    Game.TickerAge = 10 * Game.fps;
                } else {
                    Game.Popup(msg);
                }
            },

            status: function () {
                var act = [];
                var b2s = function (b) { return b ? 'on'.fontcolor('green') : 'off'.fontcolor('red'); };
                for (var i in this.actions)
                    if (this.actions[i].delay && i != 'guard')
                        act.push(i + ': ' + b2s(this.actions[i].id));
                var msg = '<p>' + act.join(', ') + '</p>';
                msg += '<p>cookie protection for max frenzy/lucky combo: ' + b2s(this.protect) + '</p>';
                this.say(msg, true);
            },

            toggle_action: function (name) {
                var action = this.actions[name];

                if (!action)
                    return;

                if (action.delay) {
                    action.id = action.id ? clearInterval(action.id) : setInterval(action.func, action.delay);
                    this.say('Action "' + name + '" turned ' + (action.id ? 'on' : 'off'));
                } else {
                    action.func();
                }
            },

            unqueue_action: function (name) {
                var to = this.actions.timeouts;
                if (to[name]) {
                    clearTimeout(to[name]);
                    delete to[name];
                }
            },

            queue_action: function (name, delay, func) {
                var to = this.actions.timeouts;
                this.unqueue_action(name);
                to[name] = setTimeout(function () { func(); delete to[name]; }, delay);
            },
        };

        var view = {
            ctrl: new Controller,
            actions: {
                72 /* H */: 'season',
                71 /* G */: 'gold',
                78 /* N */: 'gnotify',
                70 /* F */: 'frenzy',
                77 /* M */: 'main',
                83 /* S */: 'status',
                80 /* P */: 'protect',
            },
        };

        document.addEventListener('keydown', function (e) { if (this.actions[e.keyCode]) this.ctrl.toggle_action(this.actions[e.keyCode]); }.bind(view));

        [72, 71, 70, 77].map(function (key) {
            this.ctrl.toggle_action(this.actions[key]);
        }.bind(view));

    },
    save: function () {
        //use this to store persistent data associated with your mod
    },
    load: function (str) {
        //do stuff with the string data you saved previously
    },
});